define([
    "./_View",
    "dojo/_base/declare",
    "dojo/_base/lang"
], function(_View, declare, lang) {

    var _Class = declare([_View],{
        _type: null,
        constructor: function() {
            if ( this._type === null ) {
                throw new Error("You must specify a concrete type.");
            }
        },
        create: function() {
            var obj = {
                type: this._type
            };
            console.warn("You may want to override create for concrete types.");
            return obj;
        },
        _doSerialize: function(obj) {
            obj = lang.clone(obj);
            return this._serialize(obj) || obj;
        },
        _serialize: function(obj) {
            console.warn("You may want to override _serialize for concrete types.");
        },
        load: function(id) {
            return this._store.get(id).then(lang.hitch(this,'_doDeserialize'));
        },
        save: function(obj) {
            return this._store.put(this._doSerialize(obj));
        },
        remove: function(objOrId,rev) {
            var id;
            if ( typeof objOrId === "string" ) {
                id = objOrId;
            } else {
                id = this.getId(objOrId);
                rev = this.getRev(objOrId);
            }
            return this._store.remove(id,{headers:{'If-Match':'"'+rev+'"'}});
        },
        getRev: function(obj) {
            return obj._rev;
        }
    });

    return _Class;

});
