define([
    "../../store/JsonRest",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/util/QueryResults"
], function(JsonRest, declare, lang, queryResults) {

    var _View = declare([],{
        _collection: null,
        _store: null,
        constructor: function() {
            if ( this._collection === null ) {
                throw new Error("You must specify a concrete collection.");
            }
            this._store = new JsonRest({
                target: '/api/'+this._collection+'/',
                idProperty: '_id'
            });
        },
        _doDeserialize: function(obj) {
            obj = lang.clone(obj);
            return this._deserialize(obj) || obj;
        },
        _deserialize: function(obj) {
            console.warn("You may want to override _deserialize for concrete types.");
        },
        query: function(query) {
            return queryResults(this._store.query(query).map(lang.hitch(this,'_doDeserialize')));
        },
        getId: function(obj) {
            return obj._id;
        }
    });

    return _View;

});
