define([
    "./_Class",
    "dojo/_base/declare",
    "dojo/date/stamp"
], function(_Class, declare, stamp) {

    var Questions = declare([_Class],{
        _collection: 'questions',
        _type: 'Question',
        create: function() {
            var obj = {
                type: this._type,
                categories: [],
                code: "",
                content: [],
                title: ""
            };
            return obj;
        },
        _deserialize: function(obj) {
            if (obj.publicationDate) {
                obj.publicationDate = stamp.fromISOString(obj.publicationDate);
            }
        },
        _serialize: function(obj) {
            if (obj.publicationDate) {
                obj.publicationDate = stamp.toISOString(obj.publicationDate);
            }
        }
    });

    return new Questions();

});
