define([
    "./_Class",
    "./surveys",
    "dojo/_base/declare",
    "dojo/date/stamp"
], function(_Class, surveys, declare, stamp) {

    var SurveyRuns = declare([_Class],{
        _collection: 'surveyRuns',
        _type: 'SurveyRun',
        create: function() {
            var obj = {
                type: this._type,
                description: "",
                mode: "open",
                survey: null,
                title: ""
            };
            return obj;
        },
        _deserialize: function(obj) {
            if (obj.endDate) {
                obj.endDate = stamp.fromISOString(obj.endDate);
            }
            if (obj.startDate) {
                obj.startDate = stamp.fromISOString(obj.startDate);
            }
            if (obj.survey) {
                obj.survey = surveys._doDeserialize(obj.survey);
            }
        },
        _serialize: function(obj) {
            if (obj.endDate) {
                obj.endDate = stamp.toISOString(obj.endDate);
            }
            if (obj.startDate) {
                obj.startDate = stamp.toISOString(obj.startDate);
            }
            if (obj.survey) {
                obj.survey = surveys._doSerialize(obj.survey);
            }
        }
    });

    return new SurveyRuns();

});
