define([
    "./_Class",
    "dojo/_base/declare",
    "dojo/date/stamp",
    "dojo/store/JsonRest"
], function(_Class, declare, stamp, JsonRest) {

    var Surveys = declare([_Class],{
        _collection: 'surveys',
        _type: 'Survey',
        create: function() {
            var obj = {
                type: this._type,
                questions: [],
                title: ""
            };
            return obj;
        },
        _deserialize: function(obj) {
            if (obj.publicationDate) {
                obj.publicationDate = stamp.fromISOString(obj.publicationDate);
            }
        },
        _serialize: function(obj) {
            if (obj.publicationDate) {
                obj.publicationDate = stamp.toISOString(obj.publicationDate);
            }
        }
    });

    return new Surveys();

});
