define([
    "../app/Page",
    "../model/classes/surveys",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "require",
    "dojo/text!./templates/previewSurvey.html"
], function(Page, surveys, array, declare, lang, when, require, template) {
    return declare([Page],{
        contextRequire: require,
        templateString: template,
        startup: function() {
            if ( this._started ) { return; }
            this.inherited(arguments);
            if ( this.surveyId ) {
                when(surveys.load(this.surveyId))
                .then(lang.hitch(this,function(survey){
                    this.titleNode.innerHTML = survey.title || "";
                    this.surveyWidget.set('survey',survey);
                }));
            } else {
                throw new Error("No valid uid or survey passed!");
            }
        }
    });
});
